//+------------------------------------------------------------------+
//|                          Waddah Attar RSI Level ..Idea by Yamedo |
//|                                   Waddah Attar www.metaforex.net |
//+------------------------------------------------------------------+
//|           added TimeFrame feature by Linuxser 2008 for Forex TSD |
//+------------------------------------------------------------------+
//|                               modified by kris.pivo[at]gmail.com |
//+------------------------------------------------------------------+
//#property copyright "Copyright  2007, www.metaforex.net"
//#property link      "www.metaforex.net"
//---- 
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Gray        // RSI 50
#property indicator_color2 DarkGreen   // RSI 40
#property indicator_color3 Maroon      // RSI 60
#property indicator_color4 Green       // RSI 30
#property indicator_color5 Crimson     // RSI 70
#property indicator_color6 Lime        // RSI 20
#property indicator_color7 Red         // RSI 80
//---- 
extern int RSIDayPeriod =  8;
extern int TimeFrame   = 240;
//---- buffers
double P1Buffer[];   // RSI 50
double P2Buffer[];   // RSI 40
double P3Buffer[];   // RSI 60
double P4Buffer[];   // RSI 30
double P5Buffer[];   // RSI 70
double P6Buffer[];   // RSI 20
double P7Buffer[];   // RSI 80
//----------
int myPeriod = PERIOD_D1;
//---- 
double L80, L70, L60, L50, L40, L30, L20;
//----------
int init()
  {
   SetIndexBuffer(0, P1Buffer);  // RSI 50
   SetIndexBuffer(1, P2Buffer);  // RSI 40
   SetIndexBuffer(2, P3Buffer);  // RSI 60
   SetIndexBuffer(3, P4Buffer);  // RSI 30
   SetIndexBuffer(4, P5Buffer);  // RSI 70
   SetIndexBuffer(5, P6Buffer);  // RSI 20
   SetIndexBuffer(6, P7Buffer);  // RSI 80
//----------
   SetIndexStyle(0, DRAW_LINE, STYLE_DASH,1);   // RSI 50
   SetIndexStyle(1, DRAW_LINE, STYLE_DOT, 1);   // RSI 40
   SetIndexStyle(2, DRAW_LINE, STYLE_DOT, 1);   // RSI 60
   SetIndexStyle(3, DRAW_LINE, STYLE_DOT, 1);   // RSI 30
   SetIndexStyle(4, DRAW_LINE, STYLE_DOT, 1);   // RSI 70
   SetIndexStyle(5, DRAW_LINE, STYLE_DOT, 1);   // RSI 20
   SetIndexStyle(6, DRAW_LINE, STYLE_DOT, 1);   // RSI 80
   
   switch(TimeFrame)
   {
      case 1  : string TF = "M1"; break;
      case 5  : TF = "M5"; break;
      case 15 : TF = "M15"; break;
      case 30 : TF = "M30"; break;
      case 60 : TF = "H1"; break;
      case 240 : TF ="H4"; break;
      case 1440 : TF="D1"; break;
      case 10080 : TF="W1"; break;
      case 43200 : TF="MN1"; break;
      default : TF="Current";
   } 
//----------
   Comment("RSI ( " + TimeFrame + " )( " + RSIDayPeriod + " ) Level By eng.Waddah Attar www.metaforex.net");
   return(0);
  }
//----------
int deinit()
  {
   ObjectDelete("rsi20" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("txtrsi20" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("rsi30" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("txtrsi30" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("rsi40" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("txtrsi40" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("rsi50" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("txtrsi50" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("rsi60" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("txtrsi60" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("rsi70" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("txtrsi70" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("rsi80" + DoubleToStr(RSIDayPeriod, 0));
   ObjectDelete("txtrsi80" + DoubleToStr(RSIDayPeriod, 0));
//----------
   Comment("");
   return(0);
  }
//----------
int start()
  {
   int i, dayi, counted_bars = IndicatorCounted();
   double rsi1, rsi2, c1, c2, drsi, dc;
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//---- 
   for(i = limit - 1; i >= 0; i--)
     {
       dayi = iBarShift(Symbol(), TimeFrame, Time[i],true);
       if(dayi != -1)
         {
           rsi1 = iRSI(Symbol(), TimeFrame, RSIDayPeriod, PRICE_CLOSE, dayi + 1);
           rsi2 = iRSI(Symbol(), TimeFrame, RSIDayPeriod, PRICE_CLOSE, dayi + 2);
           //----
           c1 = iClose(Symbol(), TimeFrame, dayi + 1);
           c2 = iClose(Symbol(), TimeFrame, dayi + 2);
           //----
           drsi = rsi1 - rsi2;
           //----
           if(drsi == 0)
             {
               rsi2 = iRSI(Symbol(), TimeFrame, RSIDayPeriod, PRICE_CLOSE, dayi + 3);
             }
           //----
           drsi = rsi1 - rsi2;
           //----
           if(drsi == 0)
             {
               drsi = rsi1;
             }
           //----
           dc = c1 - c2;
           //----
           if(dc == 0)
             {
               c2 = iClose(Symbol(), TimeFrame, dayi + 3);
             }
           //----
           dc = c1 - c2;
           //----
           if(dc == 0)
             {
               dc = c1;
             }
           //----
           L20 = (((20 - rsi1)*dc) / drsi) + c1;
           P6Buffer[i] = L20;
           SetPrice("rsi20" + DoubleToStr(RSIDayPeriod, 0), Time[i], 
                    L20, Lime);
           SetText("txtrsi20" + DoubleToStr(RSIDayPeriod, 0), "RSI 20", 
                   Time[i], L20, Lime);
           //----
           L30 = (((30 - rsi1)*dc) / drsi) + c1;
           P4Buffer[i] = L30;
           SetPrice("rsi30" + DoubleToStr(RSIDayPeriod, 0), Time[i], 
                    L30, Green);
           SetText("txtrsi30" + DoubleToStr(RSIDayPeriod, 0), "RSI 30", 
                   Time[i], L30, Green);
           //---          
           L40=(((40 - rsi1)*dc) / drsi) + c1;
           P2Buffer[i] = L40;
           SetPrice("rsi40" + DoubleToStr(RSIDayPeriod, 0), Time[i], 
                    L40, DarkGreen);
           SetText("txtrsi40" + DoubleToStr(RSIDayPeriod, 0), "RSI 40", 
                   Time[i], L40, DarkGreen);
           //----
           L50 = (((50 - rsi1)*dc) / drsi) + c1;
           P1Buffer[i] = L50;
           SetPrice("rsi50" + DoubleToStr(RSIDayPeriod, 0), Time[i], 
                    L50, indicator_color1);
           SetText("txtrsi50" + DoubleToStr(RSIDayPeriod, 0), "RSI 50", 
                   Time[i], L50, indicator_color1);
           //----
           L60 = (((60 - rsi1)*dc) / drsi) + c1;
           P3Buffer[i] = L60;
           SetPrice("rsi60" + DoubleToStr(RSIDayPeriod, 0), Time[i], 
                    L60, Maroon);
           SetText("txtrsi60" + DoubleToStr(RSIDayPeriod, 0), "RSI 60", 
                    Time[i], L60, Maroon);
           //----
           L70 = (((70 - rsi1)*dc) / drsi) + c1;
           P5Buffer[i] = L70;
           SetPrice("rsi70" + DoubleToStr(RSIDayPeriod, 0), Time[i], 
                    L70, Crimson);
           SetText("txtrsi70" + DoubleToStr(RSIDayPeriod, 0), "RSI 70", 
                   Time[i], L70, Crimson);
           //----
           L80 = (((80 - rsi1)*dc) / drsi) + c1;
           P7Buffer[i] = L80;
           SetPrice("rsi80" + DoubleToStr(RSIDayPeriod, 0), Time[i], 
                    L80, Red);
           SetText("txtrsi80" + DoubleToStr(RSIDayPeriod, 0), "RSI 80", 
                   Time[i], L80, Red);
           }
     }
//----
   return(0);
  }
//------
void SetPrice(string name, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, Tm, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }
//--------
void SetText(string name,string txt,datetime Tm,double Prc,color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_TEXT, 0, Tm, Prc);
       ObjectSetText(name, txt, 8, "Tahoma", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSetText(name, txt, 8, "Tahoma", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     } 
  }
//+------------------------------------------------------------------+